require('dotenv').config();
const tmi = require('tmi.js');
const colors = require('colors');

console.log(colors.green.underline(process.env.API_HOST));

const client = new tmi.Client({
  options: { debug: true },
  connection: {
    secure: true,
    reconnect: true
  },
  identity: {
    username: process.env.TTV_BOT_USERNAME,
    password: process.env.TTV_BOT_OAUTH
  },
  channels: [ process.env.TTV_CHANNELS ]
});

client.connect();

// ALERTS START
// ================================
// --------------------------------
// client.on("action", (channel, userstate, message, self) => {
//     // Don't listen to my own messages..
//     if (self) return;
//     console.log('LOG: Action ');
// });
// import { ttv_alerts } from "./alerts.js";
// ttv_alerts();
// SUB | Anon => Paid
// --------------------------------
client.on("anongiftpaidupgrade", (channel, username, userstate) => {
	console.log('HYPE | @'.green+ username.yellow, 'just upgraded their Anon-Gift-Sub => PAID! Userstate?', userstate.yellow);
	client.say(channel, `Legit, @`+ username, `just upgraded their Anon-Gift-Sub to a paid sub! Thanks for the support, I feel like a real boy!`);
});
// MOD | Ban
// --------------------------------
client.on("ban", (channel, username, reason, userstate) => {
	console.log('MOD-LOG: @'.brightRed+ username.yellow, 'was banned for:'.brightRed, reason.yellow);
    client.say(channel, `/me BYE FELICIA!!! Critical hit from the MODs Ban-Hammer attack!`);
    client.say(channel, `!kappagen BOP BOP BOP `);
});
// client.on("chat", (channel, userstate, message, self) => {
//     // Don't listen to my own messages..
//     if (self) return;
//     // Do your stuff.
//       console.log('LOG: Chat');
// });
// HYPE | Bits / Cheer
// --------------------------------
client.on("cheer", (channel, userstate, message) => {
 	console.log('HYPE |'.green, userstate.yellow, 'with msg of'.green, message.yellow)
	if (message !== null){
		client.say(channel, `/me HYPE! Bits = Boto-fuel! Thanx for the support! I also found this message in a bottle "`+ message, `".`);
		client.say(channel, `!kappagen sarimoHYPE sarimoBITS`);
	} else {
		client.say(channel, `/me HYPE!!! Bits = Boto fuel! Thanx for the support!`);
    	client.say(channel, `!kappagen sarimoHYPE sarimoBITS`);
	}
    
});
// CHAT | Chat-Mode | Cleared
// --------------------------------
client.on("clearchat", (channel) => {
  console.log('LOG | Chat was cleared!'.brightRed)
    client.say(channel, `Chat Rule Reminder`);
    client.say(channel, `/me 1. Do NOT feed the Trolls!`);
    client.say(channel, `/me 2. Do NOT be a Troll!`);
    client.say(channel, `/me 3. Do NOT be another brick in the wall!`);
});
// DUPE | Connected & Connecting already logged in TMI
// --------------------------------
client.on("connected", (address, port) => {
      // console.log('LOG | Connected @'.green, address.yellow, 'on port'.green, port);
});
client.on("connecting", (address, port) => {
      // console.log('LOG | Connecting @'.green, address.yellow, 'on port'.green, port);
});
client.on("disconnected", (reason) => {
      console.log('LOG |'.brightRed, reason.yellow, 'caused a disconnection...'.brightRed);
});
// CHAT | Chat-Mode | Emote only
// --------------------------------
client.on("emoteonly", (channel, enabled) => {
      console.log('CHAT MODE: Emotes Only ');
});
// client.on("emotesets", (sets, obj) => {
//     // Here are the emotes I can use:
//       console.log('Emote Sets: IDK WHAT TO DO WITH THESE ');
//     console.log(obj);
// });
// CHAT | Chat-Mode | Followers
// --------------------------------
client.on("followersonly", (channel, enabled, length) => {
      console.log('CHAT MOD: Followers only enabled!');
});
// SUB | Gift => Paid
// --------------------------------
client.on("giftpaidupgrade", (channel, username, sender, userstate) => {
      console.log('LOG: Gift-Sub UPGRADED to a real full blown sub! ');
});
// HYPE | Hosted
// --------------------------------
client.on("hosted", (channel, username, viewers, autohost) => {
  	console.log('LOG: TYVM! For the host!');
    client.say(channel, `/me TYVM @`+ username, `we may take your viewership of`, viewers+ `, but we'll never take their FREEDOM!!! sarimoFREEDOM`);
  	client.say(channel, `!kappagen sarimoHYPE sarimoLURK`);
});
// HYPE | Hosting
// --------------------------------
client.on("hosting", (channel, target, viewers) => {
  	console.log('HYPE | Logging into'.yellow, 'Twitch TV'.brightBlue);
	// HYPE | Hosting
  	client.say(channel, `/me Stick around as we host @`+ target, `they may take our viewership of`, viewers +`, but we'll never take their FREEDOM!!! sarimoFREEDOM`);
  	client.say(channel, `!kappagen sarimoNERD sarimoKO`);
});
// CHAT | User Joined
// --------------------------------
client.on("join", (channel, username, self) => {
  console.log('LOG |'.brightBlue, username.yellow, 'joined the chat!'.brightBlue);
      if(username === 'cho0tem' ||
      	username === 'rusttv_com' ||
      	username === 'theframilyknight' ||
      	username === 'trip_228' ||
      	username === 'worgar396') {
        client.say(channel, `/me Yo @`+ username +`, wb to chat! sarimoSOUP sarimoTRIP`);
      }
});
// DUPE
// --------------------------------
client.on("logon", () => {
  // console.log('LOG | Logging into'.yellow, 'Twitch TV'.brightBlue);
});
// client.on("message", (channel, userstate, message, self) => {
//     // Don't listen to my own messages..
//     if (self) return;
// 
//     // Handle different message types..
//     switch(userstate["message-type"]) {
//         case "action":
//             // This is an action message..
//             break;
//         case "chat":
//             // This is a chat message..
//             break;
//         case "whisper":
//             // This is a whisper..
//             break;
//         default:
//             // Something else ?
//             break;
//     }
// });
client.on("messagedeleted", (channel, username, deletedMessage, userstate) => {
      console.log('LOG | Deleted MSG'.brightRed);
});
client.on("mod", (channel, username) => {
      console.log('LOG |'.brightRed, username.yellow, 'was added as a MOD'.brightRed);
});
client.on("mods", (channel, mods) => {
      console.log('LOG: Mod?'.yellow, mods);
});
client.on("notice", (channel, msgid, message) => {
      console.log('LOG: Notice? '.yellow, msgid, message);
});
// CHAT | User left
// --------------------------------
client.on("part", (channel, username, self) => {
      console.log('LOG:'.brightRed, username.yellow, 'left the chat...'.brightRed);
    // client.say(channel, `/me -1 Chatter! Where's my bounty hunters?  Essemble the *air-qoutes* search-party *air-qoutes*`);
});
//client.on("ping", () => {});
//client.on("pong", (latency) => {});
// client.on("r9kbeta", (channel, enabled) => {
//       console.log('r9kbeta? ');
// });
client.on("raided", (channel, username, viewers) => {
    client.say(channel, `/me TYVM @`+ username, `we may take your viewership of`, viewers+`, but we'll never take their FREEDOM!!! sarimoFREEDOM`);
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoKO`);
});
// client.on("raw_message", (messageCloned, message) => {
//     console.log(message.raw);
// });
client.on("reconnect", () => {
      console.log('Re-Connecting...'.green);
});
client.on("resub", function (channel, username, months, message, userstate, methods) {
    client.say(channel, `/me BLEEP! BLOOP! Legend re-sub! Thanks for your continued support!`);
    client.say(channel, `!kappagen sarimoHYPE sarimoKO`);
});
// client.on("roomstate", (channel, state) => {
//       console.log('LOG: Roomstate ');
// });
client.on("serverchange", (channel) => {
      console.log('LOG | Server changed to:'.brightRed, channel);
});
// CHAT | Chat-Mode | Slow
// --------------------------------
client.on("slowmode", (channel, enabled, length) => {
      console.log('CHAT MODE: Slow Mode enabled! ');
      client.say(channel, `CHAT-MODE: Slow`);
});
client.on("subgift", (channel, username, streakMonths, recipient, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"]; // IDK
    console.log(username.yellow, `Gift-Subbed to`.brightBlue, recipient.yellow,`methods`.brightBlue, methods.yellow,`streak`.brightBlue, streakMonths.yellow);
	// HYPE | Gift Sub
    client.say(channel, `/me Wow @`+ username, `just gifted @`+ recipient, `a sub! SPAM those emotes!`);
    client.say(channel, `!kappagen sarimoKO sarimoNERD`);
});
client.on("submysterygift", (channel, username, numbOfSubs, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"]; // IDK
    console.log(username.yellow, `Username`.brightBlue, username.yellow,`methods`.brightBlue, methods.yellow,`userstate`.brightBlue, userstate.yellow);
    client.say(channel, `/me Shit, @Anon just gifted`, numbOfSubs, `am I getting hacked?! If I get erased... I love you all! Bleep-Bloop!`);
});
client.on("subscribers", (channel, enabled) => {
	console.log('LOG | CHAT MODE | Sub-Only is'.brightRed, eneabled.yellow);
    client.say(channel, `CHAT| Subscribers mode:`, enabled);
});
client.on("subscription", function (channel, username, method, message, userstate) {
    client.say(channel, `/me BLEEP! BLOOP! New subscriber! Spam your new emotes!!! Let's see you're fav!`);
    client.say(channel, `!kappagen sarimoKO sarimoNERD`);
});
// MOD | Timeout
// --------------------------------
client.on("timeout", (channel, username, reason, duration, userstate) => {
	console.log(`MOD-LOG | Timeout @`+ username, `for`, duration, `seconds for the reason of:`, reason);
	console.log(`MOD-LOG | @`+ username, `is a `, userstate, `status!`);
	client.say(channel, `Mods have spoken! @`+ username +`, please take these `+ duration +` seconds to cooldown! Enjoy your lurk, talk to you soon!`);
  	client.say(channel, `!kappagen sarimoSALT sarimoRAGE`);
});
client.on("unhost", (channel, viewers) => {
    client.say(channel, `/me @Sarimoko has turned if hosting, please standby for further instruction!`);
});
// MOD | Un-Modded
// --------------------------------
client.on("unmod", (channel, username) => {
    client.say(channel, `Oof, modship`);
});
client.on("vips", (channel, vips) => {
    client.say(channel, `@Sarimoko is fortunate to have many great viewers but these VIPs are a few specifically to thank!`);
});
client.on("whisper", (from, userstate, message, self) => {
    if (self) return;
	console.log('DM | From:'.green, from, userstate, 'MSG:'.green, message);
    client.say(channel, `/me [+1] Inbox | Received a new SEXT message from: @`+ from +`!`);
});
// ALERTS STOP
// ================================
